// Test of 16-bit Bresenham line draw routine.

#include <conio.h>
#include <math.h>

void SetPixel( short x, short y, short c )
{
	_asm
	{
		mov ax, c
		mov ah, 0ch
		mov bh, 0
		mov cx, x
		mov dx, y
		int 10h
	}
}

void DrawLine( short x0, short y0, short x1, short y1, short c )
{
	short steep;
	short deltax;
	short deltay;
	short error;
	short x, y;
	short xstep, ystep;

	steep = abs( y1 - y0 ) > abs( x1 - x0 );

	if ( steep )
	{
		short temp = x0;
		x0 = y0;
		y0 = temp;
		temp = x1;
		x1 = y1;
		y1 = temp;
		SetPixel( y0, x0, c );
	}
	else
		SetPixel( x0, y0, c );

	deltax = abs( x1 - x0 );
	deltay = abs( y1 - y0 );
	error = 0;
	x = x0;
	y = y0;

	if ( x0 < x1 )
		xstep = 1;
	else
		xstep = -1;

	if ( y0 < y1 )
		ystep = 1;
	else
		ystep = -1;

	while ( x != x1 )
	{
		x += xstep;
		error += deltay;
		if ( (2 * error) > deltax )
		{
			y += ystep;
			error -= deltax;
		}

		if ( steep )
			SetPixel( y, x, c );
		else
			SetPixel( x, y, c );
	}
}

void main(void)
{
	_asm
	{
		mov ax, 13h
		int 10h
	}
	// Horizontal lines both directions:
	DrawLine( 0, 0, 100, 0, 9 );
	DrawLine( 100, 10, 0, 10, 9 );
	// Vertical lines both directions:
	DrawLine( 0, 20, 0, 120, 9 );
	DrawLine( 10, 120, 10, 20, 9 );
	// Diagonal both directions:
	DrawLine( 50, 30, 150, 130, 4 );
	DrawLine( 155, 130, 55, 30, 4 );
	DrawLine( 50, 130, 150, 30, 4 );
	DrawLine( 155, 30, 55, 130, 4 );
	// Almost horizontal:
	DrawLine( 0, 150, 319, 149, 15 );
	DrawLine( 319, 151, 0, 150, 15 );
	// Almost vertical:
	DrawLine( 200, 0, 199, 199, 15 );
	DrawLine( 201, 199, 200, 0, 15 );
	getch();
}




